package jalview.rest;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jalview.gui.Desktop;
import jalview.gui.SequenceFetcher;
import jalview.util.DBRefUtils;

public class FetchSequenceEndpoint extends EndpointAsync
{
  protected String name = "fetchsequence";

  @Override
  protected void initialise(HttpServletRequest request,
          HttpServletResponse response)
  {
    // note that endpointName should always be "fetchsequence"

    String[] parameters = getEndpointPathParameters(request);

    // check we can run fetchsequence
    if (parameters.length < 2)
    {
      returnError(request, response,
              "requires 2 path parameters: dbname, ids");
      return;
    }

    String dbName = parameters[0];
    String dbId = parameters[1];

    setId(request, dbName + "::" + dbId);
    if (checkStatus(request, response))
      return;

    String db = DBRefUtils.getCanonicalName(dbName);
    Desktop desktop = Desktop.instance;
    SequenceFetcher sf = new SequenceFetcher(desktop, db, dbId);
    setCompletableFuture(sf.ok_actionPerformed(true));
  }

  protected void process(HttpServletRequest request,
          HttpServletResponse response)
  {
    // all the work being done by the SequenceFetcher!
  }
}
